<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Projets de Maitrise</TITLE>
<style>
em {color:#802000; font-weight:bold;}
.bi {color:#005000; font-weight:bold; font-size:18pt; 
   font-family:Times,serif;}
.bl {color: #a00000}
</style>

</HEAD>

<BODY BACKGROUND="Snback.gif">

<!--
<BODY BACKGROUND="Snback.gif" BGCOLOR="#C0E0E0" TEXT="#000000" 
  LINK="#604000" VLINK="#882060" ALINK="#ff0000">
-->


<CENTER><H1><FONT COLOR=#d20000>
Projets de Maîtrise 2000/01
</FONT></H1>
</CENTER>
<P>



<b>
<font color=#006000>(Les projets obsolètes, de l'année dernière
  <a href="maitr99.html">se trouvent ici.</a></font>
<p>

J'offre <em>en principe</em> 2 sujets mais si parmi vous il y a des amoureux 
d'imagerie
ou de la (<em>vraie</em>) programmation fonctionnelle, nous pouvons encore
négocier d'autres sujets...<p>

<P>
<P>
<HR WIDTH="95%" ALIGN=CENTER>
<P>

Les projets officiels sont :
<OL>
<LI> <A HREF="#shapav">Construction d'un <em>shader</em> pour créer des 
     pavages pour BMRT</A>
     
<LI> <a href="#jart">Construction d'un lanceur de rayons en Java</a>
</OL>
<P>


<p>
<HR WIDTH="70%" ALIGN=CENTER size=6 noshade>
<P>


<A name="shapav">
<H2> Construction d'un <em>shader</em> pour créer des pavages pour BMRT </h2>

<p>

<p>
<center>
<img src="fig12.7.jpg" align=absmiddle>
<br>
Fig. Une image rendue par BMRT
</center><p>

<!-- 
<P>
<font color="#F00000">
(<img src="../../icons/starroll.gif" align=abscenter> &nbsp; Ce projet est déjà pris par.)
</font>
<p>

-->


<OL>
<LI> <H3>Énoncé et cahier des charges</H3>
  BMRT (<em>Blue Moon Rendering Tools</em>) est un paquetage multi-plate-forme 
  gratuit qui contient un visualiseur rapide ainsi qu'un lanceur de rayons 
  concurrentiel au POVRay. 
  Il est compatible avec le "protocol Renderman" utilisé -
  par exemple - par Pixar. On peut utiliser BMRT comme une librairie ou comme
  une application indépendante (<em>ce que nous allons faire en TD d'Imagerie 
  en deuxième semestre</em>).<p>
  
  Son trait caractéristique est la possibilité de faire
  des textures dynamiques (crées pendant l'exécution du programme de rendu) 
  très complexes et variables, grâce aux "shaders": <em>procédures</em> 
  écrites dans un langage de programmation (proche du "C").<p>
  
  Le projet consiste à programmer une collection de dessins géométriques, 
  peut-être dans le style Celte ou Islamique, qui peuvent être utilisés 
  comme des décorations surfaciques de scènes rendues par le lanceur 
  <b>rendrib</b> de BMRT. Le carrélage ci-dessus en est un exemple, mais 
  vous pouvez imaginer des tapis Perse (Hamid vous pourra peut-être fournir 
  des exemples concrets...), des mosaïques architecturales
  très elaborées, etc. <p>
  
  L'étudiant devra écrire quelques procédures en "SL". Voici le texte du shader
  <a href="ceramictiles.sl">Ceramictiles</a> utilisé pour faire du carrelage. Il
  utilise d'autres shaders. Jetez un coup d'oeil sur <a href="noises.h">noises.h</a>
  et sur <a href="reflections.h">reflections.h</a> <p>
  
  Il faudra tester le résultat en écrivant quelques scènes dans le langage 
  spécifique à Renderman, en format RIB. <a href="fig12.7.rib">Voici l'exemple 
  de la théière</a>
  sur l'image ci-dessus. La théière elle-même est un exemple standard de BMRT.
  <a href="teapot.rib">Elle est ici</a>.<p>
  
  (D'autres exemples? Voici <a href="limbo.rib">limbo.rib</a>, un très gros
  fichier qui génère des animations, dont un cadre 
  <a href="f003.jpg">se trouve ici</a>).
 
<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <h3>Commentaires</h3>

  Il <em>ne s'agit pas</em> de faire de choses trop complexes ; 
  il suffit de choisir un simple modèle fait à la main, et de forcer le 
  programme d'exploiter la symétrie de refléxion, évent. la rotation de 90 ou 
  180 degrés, et la translation. <p>
  
  Le shader doit ajouter un peu de reflets lumineux, d'effets 3D, de 
  dégradation, rendre le dessin géométrique un peu plus réaliste. Vous allez
  vous inspirer du pavage ci-dessus, et d'un tutorial sur shaders dans
  "RenderMan Notes" référencés ci-dessous.
  <p>
  
  BMRT est installé et disponible sous Linux. Vérifiez 
  <big><tt>/usr/share/soft</tt></big>. 
  (Parfois ce répertoire n'est pas accessible...) Si quelqu'un veut une 
  version Windows il suffit de l'importer du site de Larry Gritz.
  

<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <h3>Références</h3>

<ul>

<li> <a href="http://www.bmrt.org/">La page principale de Larry Gritz et 
     BMRT</a>

<li> <a href="http://users.info.unicaen.fr/~karczma/docs/bmrtdoc/bmrt.html">
     Documentation locale, mais un peu vieille (version 2.4)</a>

<li> <a href="http://users.info.unicaen.fr/~karczma/docs/RManNotes/">
     RenderMan Notes</a>. Très important pour vous !


<li> <a href="http://minerva.ca.scad.edu/faculty/kesson/CA301/">Les cours de Malcolm Kesson</a>
     sur shaders.

<li> <a href="http://www.renderman.org/RMR/">Renderman Repository</a>. Centaines d'exemples,
     scènes, shaders, etc.

<li> <a href="http://www9.informatik.uni-erlangen.de/eng/research/rendering/vision/">Une
     implantation expérimentale ("Vision") compatible RenderMan</a>. Beaucoup de travail,
     mais j'ignore si on peut en profiter.

<li> <a href="http://www.tabletoptelephone.com/~hopspage/HopsTiles.html" target=_top>Les pages de
  Hollister (Hop) David</a>. <em>Essentiel.</em>. Une mine inépuisable d'<em>exemples de pavages</em>.

<li> <a href="http://www.geom.umn.edu/apps/gallery.html" target=_top>University of Minnesota Geometry Center: Interactive on-line geometry</a>. Vérifiez les paquetages, notamment Kali,
et QuasiTiler.

<li> <a href="http://www.geocities.com/williamwchow/javagraf/javagraf.htm">Tesselations et applets
 Java.</a>
 
<li> <a href="http://sd.znet.com/~wchow/gridtile.htm">Une autre page du même auteur, aussi autour
     de pavages</a>

<li> <a href="http://ls7-www.cs.uni-dortmund.de/~kohnhors/kosima/english.htm">Un projet d'un
  étudiant à Dortmund, sur pavages.</a>

</ul>
<p>

</OL>
<P>&nbsp; <p>
<P>
<HR WIDTH="100%" ALIGN=CENTER size=6 noshade>
<P>
<P>&nbsp; <p>


<A name="jart">
<H2> Construction d'un lanceur de rayons en Java </h2>

<p>

<p>
<center>
<img src="reflect.jpg" align=absmiddle>
<br>
Fig. Une image rendue par ray++ (volé du site de Martin Reinecke et
 Andreas Kahler)
</center><p>



<OL>

<LI> <H3>Énoncé et cahier des charges</H3>

Écrire un Lanceur de Rayons (Ray Tracer), ce qui était jadis une
 tâche <i>"professionnelle"</i> est devenu un exercice pédagogique pour
 les étudiants de licence/maîtrise, dans des établissements où la
 synthèse d'images est enseigné <b>sérieusement</b>. Dans une des
 compétitions publiques liées à une conférence internationale les
 participants avaient 72 heures pour écrire un lanceur de rayons, et
 les résultats étaient spectaculaires... (D'ailleurs, le vainqueur 
 était un team Français qui a construit le lanceur en CAML, un langage
 fonctionnel...)
 <p>
    
 Le but du projet est d'exploiter la couche objet de Java, ainsi que
 la facilité de faire des <i>plug-ins</i> par le chargement automatique
 et dynamique des classes, et faire un logiciel <em>extensible</em>, et
 <em>integré et homogène</em>, où <p>
    
 <ul>
  <li> Le noyau <i>et</i> la description de la scène rendue seront écrits
       en Java. La scène sera compilée indépendamment de la création de 
       l'image final, et attachée au lanceur.<p>
       
  <li> Il ne s'agit pas de faire un applet, mais une application Java
       locale, capable de rendre les objets géométriques classiques, comme
       sphères, cubes, etc., ainsi que des polygônes (triangles et
       rectangles). Le minimum de texturation sera demandé, et la prise
       en compte des techniques d'éclairage standard, avec la spécularité
       de Phong et la réflexion récursive.<p>
         
  <li> Le style de programmation doit être le plus géométrique et invariant
       possible. Il faudra exploiter la puissance d'une bonne représentation
       mathématique des vecteurs, opérateurs, équations... et de ne jamais
       "bricoler". Bien sûr, j'offrirai tout le support nécessaire.<p>
        
  <li> (<em>Optionnel</em>) 
       La texturation dynamique par les modules du rendu des surfaces sera
       extensible par les "shaders" (réalisés comme <i>plug-ins</i>).<br>
       (Jusqu'à présent seulement quelques lanceurs basés sur le protocole
       Renderman offrent des shaders ; voici une nouveauté qui peut rendre
       ce projet très intéressant aux autres, et apporter de la fame, argent
       et l'amour à son créateur...)<p>
 </ul>

<p>

<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>

<LI> <h3>Commentaires</h3>

    Il existent de très nombreuses implantations raisonnables des lanceurs
    dew rayons en C++ dont le code  est rendu public, (p. ex. OOGL et Ray++)
    et plusieurs implantations en Java. Quelques unes sont <em>très</em>
    primitives, sans intérêt (sauf pour piquer quelques éléments du
    codage en Java), au moins une (RAJA) est un lanceur très bon.
    <p>
    
    Nos ambitions sont moyennes, il n'est pas souhaitable d'avoir un lanceur
    capable de rendre toute scène possible, mais <em>le chargement dynamique
    des classes</em> doit être implanté. Le minimum de texturation signifie
    par exemple l'échiquier ou une surface rugueuse.

<p>

<P>
<HR WIDTH="75%" ALIGN=CENTER size=4 noshade>
<P>


<LI> <h3>Références</h3>

<ul>
 <li> Voici un applet qui marche :
    <a href="http://www.cs.brown.edu/people/dlg/java/trace/home.html">avec
      un tutorial de Daniel Gould</a>
 
 <li> <a href="http://www.frontiernet.net/~imaging/raytracing.html">Un
    autre applet</a>
    
 <li> <a href="http://www.mpa-garching.mpg.de/~martin/ray++/raymain.html">
   Référence à Ray++</a>

 <li><a href="http://www.photon.at/~werner/light/"> Un autre lanceur en 
   C++</a>, de Werner Benger : une vraie folie qui inclut les images 
   des trous noirs et autres phénomènes relativistes...

 
 <li> <a href="http://www.cse.msu.edu/~babbagej/ray/ray.html">Un lanceur
   en Java écrit par un gosse plus jeune que vous ! </a> (Avec sources)
 
 <li> <a href="http://dyna.iperweb.com/jtrace/index.html">TraceLet applet </a>
   de Jeff Nabel
 
 <li> <a href="http://www.cs.wpi.edu/~matt/courses/cs563/talks/raytrace/RTAindex.html">
   Un article sur l'optimisation des lanceurs</a>
   de Steven Segenchuk
   
 <li> <a href="http://rajaweb.free.fr/">Le site de RAJA</a>. Important !
 
 <li> <a href="http://www.gnu.org/software/panorama/panorama.html">Panorama</a>
   Ceci, encore une fois est en C++ et non pas en java, mais montre l'utilité
   des plug-in dynamiques.
   
 <li> <a href="http://www.education.siggraph.org/materials/HyperGraph/raytrace/rtrace0.htm">
   Un site pédagogique sur la technique de lancer des rayons.</a>
 
 <li> <a href="http://www.cc.gatech.edu/grads/l/Will.Luo/java.html">
 Le site de Will Luo, avec un applet </a>
 
 <li> <a href="http://www.graphics.lcs.mit.edu/vrmlTracer/index.html">
   Un lanceur capable de rendre des scènes en VRML</a>
   de B. Glazer.

</ul>


</OL>





<P>

<HR WIDTH="95%" ALIGN=CENTER size=10 noshade>
<P>

Questions? 
Suggestions? Alors n'hésitez pas :
<A HREF="mailto:karczma@info.unicaen.fr">mailto:karczma@info.unicaen.fr</A>
<P>

</b>
</BODY>
</HTML>








